<?php

class AddFormReponseTables extends CakeMigration {

/**
 * Migration description
 *
 * @var string
 */
	public $description = 'add_form_reponse_tables';

/**
 * Actions to be performed
 *
 * @var array $migration
 */
	public $migration = array(
		'up' => array(
			'create_table' => array(
				'ev_form_builder_form_responses' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'form_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'user_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'indexes' => array(
						'PRIMARY' => array('column' => 'id', 'unique' => true),
						'fk_form_responses_forms_idx' => array('column' => 'form_id', 'unique' => false),
						'fk_form_responses_users_idx' => array('column' => 'user_id', 'unique' => false),
					),
					'tableParameters' => array('charset' => 'utf8mb4', 'collate' => 'utf8mb4_unicode_ci', 'engine' => 'InnoDB'),
				),
				'ev_form_builder_question_block_responses' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'form_response_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'question_block_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'indexes' => array(
						'PRIMARY' => array('column' => 'id', 'unique' => true),
						'fk_question_block_responses_form_responses_idx' => array('column' => 'form_response_id', 'unique' => false),
						'fk_question_block_responses_question_blocks_idx' => array('column' => 'question_block_id', 'unique' => false),
					),
					'tableParameters' => array('charset' => 'utf8mb4', 'collate' => 'utf8mb4_unicode_ci', 'engine' => 'InnoDB'),
				),
				'ev_form_builder_question_responses' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'question_block_response_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'question_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'response' => array('type' => 'text', 'null' => true, 'default' => null, 'collate' => 'utf8mb4_general_ci', 'charset' => 'utf8mb4'),
					'indexes' => array(
						'PRIMARY' => array('column' => 'id', 'unique' => true),
						'fk_question_responses_question_block_responses_idx' => array('column' => 'question_block_response_id', 'unique' => false),
						'fk_question_responses_questions_idx' => array('column' => 'question_id', 'unique' => false),
					),
					'tableParameters' => array('charset' => 'utf8mb4', 'collate' => 'utf8mb4_unicode_ci', 'engine' => 'InnoDB'),
				),
				'ev_form_builder_form_response_associations' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'form_response_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'model' => array('type' => 'string', 'null' => true, 'default' => null, 'length' => 250, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'model_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false),
					'indexes' => array(
						'PRIMARY' => array('column' => 'id', 'unique' => true),
						'fk_form_response_associations_form_responses_idx' => array('column' => 'form_response_id', 'unique' => false),
						'fk_form_response_associations_model_model_idx' => array('column' => array('model', 'model_id'), 'unique' => false),
					),
					'tableParameters' => array('charset' => 'utf8mb4', 'collate' => 'utf8mb4_unicode_ci', 'engine' => 'InnoDB'),
				)
			),
		),
		'down' => array(
			'drop_table' => array(
				'ev_form_builder_form_responses',
				'ev_form_builder_question_block_responses',
				'ev_form_builder_question_responses',
				'ev_form_builder_form_response_associations',
			),
		),
	);

/**
 * Before migration callback
 *
 * @param string $direction Direction of migration process (up or down)
 * @return bool Should process continue
 */
	public function before($direction) {
		return true;
	}

/**
 * After migration callback
 *
 * @param string $direction Direction of migration process (up or down)
 * @return bool Should process continue
 */
	public function after($direction) {
		return true;
	}
}
